<script>
import { mapState, mapActions } from "vuex";

export default {
  name: "Home",

  data() {
    return {
      isVisibleEditOrganization: false,
      isVisibleEditNotice: false,
      isVisibleThanksLetter: false,
      isVisibleTemplatePreview: false,

      image: null,
      editUser: null,

      notice: "",

      thanksLetter: {
        organization: "",
        fullName: "",
        stamp: null,
        signature: null,
      },

      success: false,
    };
  },

  watch: {
    image() {
      let imagePreview = document.getElementById("preview");

      if (this.image) {
        imagePreview.src = URL.createObjectURL(this.image);
      } else {
        imagePreview.src = "";
      }
    },

    "thanksLetter.stamp"() {
      let imagePreview = document.getElementById("stamp");

      if (this.thanksLetter.stamp) {
        imagePreview.src = URL.createObjectURL(this.thanksLetter.stamp);
      } else {
        imagePreview.src = "";
      }
    },

    "thanksLetter.signature"() {
      let imagePreview = document.getElementById("signature");

      if (this.thanksLetter.signature) {
        imagePreview.src = URL.createObjectURL(this.thanksLetter.signature);
      } else {
        imagePreview.src = "";
      }
    },
  },

  computed: {
    ...mapState({
      user: (state) => state.user.user,
      template: (state) => state.template.template,
    }),

    organizationName() {
      return this.editUser?.name !== null
        ? this.editUser?.name
        : `Организация-${this.editUser.id}`;
    },

    organizationDescription() {
      return this.editUser?.description !== null
        ? this.editUser?.description
        : "";
    },

    organizationContacts() {
      return this.editUser?.contacts !== null ? this.editUser?.contacts : "";
    },

    formattedImagePath() {
      if (this.editUser?.avatar !== null) {
        return this.editUser?.avatar.url.full_size;
      } else {
        return require("../assets/logo.svg");
      }
    },

    formattedButtonText() {
      return this.template?.organization_title
        ? "Изменить благодартсвенное письмо"
        : "Создать благодартсвенное письмо";
    },

    showTemplate() {
      return this.template?.organization_title;
    },
  },

  methods: {
    ...mapActions({
      uploadImage: "user/uploadImage",
      updateUser: "user/updateUser",
      checkUser: "user/checkUser",
      sendNotification: "notifications/sendNotification",
      updateTemplate: "template/updateTemplate",
      storeSeal: "template/storeSeal",
      storeSign: "template/storeSign",
      loadTemplate: "template/loadTemplate",
    }),

    updateUserRequest() {
      this.updateUser({
        name: this.editUser.name,
        description: this.editUser.description,
        contacts: this.editUser.contacts,
      }).then(() => {
        if (this.image) {
          this.uploadImage({
            image: this.image,
          }).then(() => {
            this.isVisibleEditOrganization = false;
            this.checkUser();
          });
        } else {
          this.isVisibleEditOrganization = false;
          this.checkUser();
        }
      });
    },

    sendNotice() {
      this.sendNotification({ message: this.notice }).then(() => {
        this.isVisibleEditNotice = false;

        this.success = true;
        this.notice = "";

        setTimeout(() => {
          this.success = false;
        }, 2000);
      });
    },

    updateTemplateRequest() {
      this.updateTemplate({
        organization: this.thanksLetter.organization,
        fullName: this.thanksLetter.fullName,
      })
        .then(() => {
          if (this.thanksLetter.stamp) {
            this.storeSeal({ image: this.thanksLetter.stamp });
          }

          if (this.thanksLetter.signature) {
            this.storeSign({ image: this.thanksLetter.signature });
          }
        })
        .then(() => {
          this.isVisibleThanksLetter = false;

          setTimeout(() => {
            this.thanksLetter = {
              organization: "",
              fullName: "",
              stamp: null,
              signature: null,
            };
          }, 10000);

          setTimeout(() => {
            this.loadTemplate();
          }, 5000);
        });
    },

    openTemplateEdit() {
      if (this.template) {
        this.thanksLetter = {
          organization: this.template.organization_title,
          fullName: this.template.general_title,
          stamp: null,
          signature: null,
        };

        this.isVisibleThanksLetter = true;
      } else {
        this.isVisibleThanksLetter = true;
      }
    },
  },

  mounted() {
    this.editUser = Object.assign({}, this.user);
    this.loadTemplate();
  },
};
</script>

<template>
  <div class="home">
    <v-alert v-if="success" class="home__notify" type="success">
      Уведомление успешно отправлено
    </v-alert>

    <div v-if="editUser" class="home__block block-wrapper home__block_flex">
      <v-dialog v-model="isVisibleEditOrganization" width="440">
        <template v-slot:activator="{ on, attrs }">
          <v-btn color="info" v-bind="attrs" v-on="on">
            <v-icon left> mdi-pencil-outline </v-icon>
            Редактировать
          </v-btn>
        </template>

        <v-card class="organization-edit">
          <v-card-title class="text-h5 lighten-2 mb-8 pt-8 pb-0">
            Редактирование организации
          </v-card-title>

          <v-card-text>
            <form>
              <v-text-field
                v-model="editUser.name"
                label="Название организации"
                outlined
              ></v-text-field>

              <v-textarea
                v-model="editUser.description"
                outlined
                name="input-7-4"
                label="Описание"
                value=""
              ></v-textarea>

              <v-text-field
                v-model="editUser.contacts"
                label="Контакты"
                outlined
              ></v-text-field>

              <v-file-input
                v-model="image"
                accept="image/*"
                label="Логотип"
                outlined
              ></v-file-input>

              <img
                v-show="image"
                class="organization-edit__image mb-4"
                id="preview"
                alt=""
              />
            </form>
          </v-card-text>

          <v-divider></v-divider>

          <v-card-actions class="pl-6 pt-4 pb-4">
            <v-btn color="info" @click="updateUserRequest">Сохранить</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog v-model="isVisibleEditNotice" width="440">
        <template v-slot:activator="{ on, attrs }">
          <v-btn color="info" v-bind="attrs" v-on="on">
            <v-icon left> mdi-bell-outline </v-icon>
            Создать уведомление
          </v-btn>
        </template>

        <v-card class="organization-edit">
          <v-card-title class="text-h5 lighten-2 mb-8 pt-8 pb-0">
            Создание уведомления
          </v-card-title>

          <v-card-text>
            <form>
              <v-textarea
                v-model="notice"
                outlined
                name="input-7-4"
                label="Уведомление"
                value=""
              ></v-textarea>
            </form>
          </v-card-text>

          <v-divider></v-divider>

          <v-card-actions class="pl-6 pt-4 pb-4">
            <v-btn color="info" @click="sendNotice">Отправить</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>

    <div class="home__block block-wrapper organization">
      <div class="organization__preview">
        <img :src="formattedImagePath" height="130" width="130" alt="" />

        <div class="organization__description">
          <h4>
            {{ organizationName }}
          </h4>

          <p>
            {{ organizationDescription }}
          </p>
        </div>
      </div>

      <div class="organization__contacts">
        <p>Контакты: {{ organizationContacts }}</p>
      </div>

      <v-divider class="mb-6 mt-6"></v-divider>

      <div v-if="showTemplate" class="organization__template template mb-4">
        <p>
          <span>Название организации:</span> {{ template.organization_title }}
        </p>
        <p><span>ФИО руководителя:</span> {{ template.general_title }}</p>

        <div class="template__images mt-2">
          <div v-if="template.seal" class="template__image">
            <img :src="template.seal.url.full_size" alt="" />
          </div>
          <div v-if="template.sign" class="template__image">
            <img :src="template.sign.url.full_size" alt="" />
          </div>
        </div>
      </div>

      <v-btn class="mr-2" color="info" @click="openTemplateEdit">
        <v-icon left> mdi-pencil-outline </v-icon>
        {{ formattedButtonText }}
      </v-btn>

      <v-btn
        v-if="showTemplate"
        class="mt-2"
        color="info"
        @click="isVisibleTemplatePreview = true"
      >
        <v-icon left> mdi-eye </v-icon>
        Предпросмотр
      </v-btn>

      <v-dialog v-model="isVisibleTemplatePreview" width="580" height="820">
        <v-card v-if="template">
          <v-card-text class="pa-0">
            <div class="template-preview d-flex">
              <img src="../assets/images/template.png" alt="" />

              <h1 class="template-preview__organization-title">
                {{ template.organization_title }}
              </h1>

              <p class="template-preview__general-title">
                {{ template.general_title }}
              </p>

              <img
                class="template-preview__sign"
                :src="template.sign.url.full_size"
                alt=""
              />

              <img
                class="template-preview__seal"
                :src="template.seal.url.full_size"
                alt=""
              />
            </div>
          </v-card-text>
        </v-card>
      </v-dialog>

      <v-dialog v-model="isVisibleThanksLetter" width="440">
        <v-card class="organization-edit">
          <v-card-title class="text-h5 lighten-2 mb-8 pt-8 pb-0">
            Создание письма
          </v-card-title>

          <v-card-text>
            <form>
              <v-text-field
                v-model="thanksLetter.organization"
                label="Название организации"
                outlined
              ></v-text-field>

              <v-text-field
                v-model="thanksLetter.fullName"
                label="ФИО руководителя"
                outlined
              ></v-text-field>

              <v-file-input
                v-model="thanksLetter.stamp"
                accept="image/*"
                label="Печать"
                outlined
              ></v-file-input>

              <img
                v-show="thanksLetter.stamp"
                class="organization-edit__image mb-4"
                id="stamp"
                alt=""
              />

              <v-file-input
                v-model="thanksLetter.signature"
                accept="image/*"
                label="Подпись"
                outlined
              ></v-file-input>

              <img
                v-show="thanksLetter.signature"
                class="organization-edit__image mb-4"
                id="signature"
                alt=""
              />
            </form>
          </v-card-text>

          <v-divider></v-divider>

          <v-card-actions class="pl-6 pt-4 pb-4">
            <v-btn color="info" @click="updateTemplateRequest">Сохранить</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.home {
  height: 100%;
  overflow: auto;
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 100px 32px 60px;
  position: relative;

  &__notify {
    position: absolute;
    bottom: 32px;
    left: 0;
    right: 0;
    max-width: 500px;
    margin: 0 auto;
    z-index: 9999;
  }

  .template {
    p {
      span {
        font-weight: 500;
      }
    }

    &__images {
      display: flex;
      align-items: center;
      gap: 8px;
    }

    &__image {
      display: flex;
      align-items: center;
      max-width: 75px;
      max-height: 75px;

      img {
        width: 100%;
        height: auto;
        border-radius: 4px;
      }
    }
  }

  &__block {
    max-width: 570px;
    width: 100%;
    height: fit-content;
    padding: 16px;

    &_flex {
      display: flex;
      flex-wrap: wrap;
      gap: 10px;
    }

    &:not(:last-child) {
      margin-bottom: 24px;
    }
  }

  .organization {
    &__preview {
      display: flex;
      margin-bottom: 24px;

      img {
        margin-right: 16px;
        border-radius: 10px;
      }
    }

    &__description {
      h4 {
        font-size: 16px;
        margin-bottom: 8px;
        line-height: 30px;
      }

      p {
        font-size: 14px;
      }
    }

    &__contacts {
      p {
        font-size: 12px;
      }
    }
  }
}
</style>
